unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, Data.DB,
  IBCustomDataSet, IBQuery, IBDatabase, FMX.ListBox, FMX.Edit, System.IOUtils,
  UnitV, Unit2, Unit3, Unit4, Unit5, Data.FMTBcd, Data.SqlExpr, Data.DBXCommon, Data.DbxSqlite ;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button0: TButton;
    ComboBox1: TComboBox;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SQLConnection1: TSQLConnection;
    SQLQuery1: TSQLQuery;
    procedure Button0Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { private 錾 }
    DatFile : string ;  // f[^t@C
    procedure OpenDatFile(fn:string) ;
    procedure SaveDatFile(fn:string) ;
  public
    { public 錾 }
    tr : TDBXTransaction ;
    procedure DataBaseConnect ;
    procedure DataBaseDisConnect ;
    function  DataTableCheck(t:string) : Boolean ;
    function  DataTableMaking1 : Boolean ;
    function  DataTableDelete1 : Boolean ;
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

// f[^t@Cǂݍ
procedure TForm1.OpenDatFile(fn:string) ;
var
   F : TextFile ;
   s : string ;
   i : integer ;
begin
   DBserv := '';
   DBfold := 'C:\data\';
   DBname := 'ADDRESS.S3DB';
   Form5.Width := 320 ;
   Form5.Height:= 240 ;
   for i:=0 to Form5.StringGrid1.ColumnCount-1 do
      Form5.StringGrid1.Columns[i].Width := 80;

   // ǂݍ
   if not(FileExists(fn)) then exit;
   try
      AssignFile(F, fn);
      FileMode := 0;
      Reset(F);

      ReadLn(F, DBserv);
      ReadLn(F, DBfold);
      ReadLn(F, DBname);
      ReadLn(F, s);  Form1.Left  := SInt(s) ;
      ReadLn(F, s);  Form1.Top   := SInt(s) ;
      ReadLn(F, s);  Form2.Left  := SInt(s) ;
      ReadLn(F, s);  Form2.Top   := SInt(s) ;
      ReadLn(F, s);  Form3.Left  := SInt(s) ;
      ReadLn(F, s);  Form3.Top   := SInt(s) ;
      ReadLn(F, s);  Form4.Left  := SInt(s) ;
      ReadLn(F, s);  Form4.Top   := SInt(s) ;
      ReadLn(F, s);  Form5.Left  := SInt(s) ;
      ReadLn(F, s);  Form5.Top   := SInt(s) ;
      ReadLn(F, s);  Form5.Width := SInt(s) ;
      ReadLn(F, s);  Form5.Height:= SInt(s) ;
      for i:=0 to Form5.StringGrid1.ColumnCount-1 do begin
         ReadLn(F, s);
         Form5.StringGrid1.Columns[i].Width := SInt(s);
      end;

      CloseFile(F);
   except
      CloseFile(F);
   end;
end;

// f[^t@Cۑ
procedure TForm1.SaveDatFile(fn:string) ;
var
   F : TextFile ;
   s : string ;
   i : integer ;
begin
   try
      AssignFile(F, fn);
      ReWrite(F);

      WriteLn(F, DBserv);
      WriteLn(F, DBfold);
      WriteLn(F, DBname);
      s := IntToStr(Form1.Left);    WriteLn(F, s);
      s := IntToStr(Form1.Top);     WriteLn(F, s);
      s := IntToStr(Form2.Left);    WriteLn(F, s);
      s := IntToStr(Form2.Top);     WriteLn(F, s);
      s := IntToStr(Form3.Left);    WriteLn(F, s);
      s := IntToStr(Form3.Top);     WriteLn(F, s);
      s := IntToStr(Form4.Left);    WriteLn(F, s);
      s := IntToStr(Form4.Top);     WriteLn(F, s);
      s := IntToStr(Form5.Left);    WriteLn(F, s);
      s := IntToStr(Form5.Top);     WriteLn(F, s);
      s := IntToStr(Form5.Width);   WriteLn(F, s);
      s := IntToStr(Form5.Height);  WriteLn(F, s);
      for i:=0 to Form5.StringGrid1.ColumnCount-1 do begin
         s := IntToStr(Round(Form5.StringGrid1.Columns[i].Width)) ;
         WriteLn(F, s);
      end;

      CloseFile(F);
   except
      CloseFile(F);
      if TFile.Exists(fn) then TFile.Delete(fn);
   end;
end;

// f[^x[Xɐڑ
procedure TForm1.DataBaseConnect ;
begin
   // f[^x[Xڑ
   SQLConnection1.Connected := False ;
   SQLConnection1.Params.Add('Database='+DBfold+DBname);
   try
      SQLConnection1.Connected := true;
   except
      // G[f[^x[Xؒf
      DataBaseDisConnect ;
   end;
end;

// f[^x[Xؒf
procedure TForm1.DataBaseDisConnect ;
begin
   SQLQuery1.Active := False;
   SQLConnection1.Connected := False ;
end;

// f[^e[ũ`FbN
function TForm1.DataTableCheck(t:string) : Boolean ;
begin
   ComboBox1.Items.Clear ;
   SQLConnection1.GetTableNames(ComboBox1.Items);
   if ComboBox1.Items.IndexOf(t) >= 0 then
      Result := True
   else
      Result := False ;
end;

// f[^e[u TABLE1 쐬
function TForm1.DataTableMaking1 : Boolean ;
begin
   Result := False ;
   try
      SQLQuery1.Close;
      SQLQuery1.ParamCheck := False;
      with SQLQuery1.SQL do begin
         Clear ;
         Add('CREATE TABLE ' + TABLE1 + ' (' );
         Add('  N INTEGER NOT NULL UNIQUE,');
         Add('  PNAME TEXT,');
         Add('  PKANA TEXT,');
         Add('  ZIP1  TEXT,');
         Add('  ZIP2  TEXT,');
         Add('  ADR1  TEXT,');
         Add('  ADR2  TEXT,');
         Add('  TEL   TEXT,');
         Add('  FAX   TEXT,');
         Add('  PHONE TEXT,');
         Add('  BIKO  TEXT');
         Add('  );');
      end;
      if not(SQLQuery1.Prepared) then SQLQuery1.Prepared := True ;
      SQLQuery1.ExecSQL;
      Result := True ;
   except
      ;
   end;
   SQLQuery1.Active := False ;
end;

// f[^e[u TABLE1 폜
function TForm1.DataTableDelete1 : Boolean ;
begin
   Result := False ;
   try
      SQLQuery1.Close;
      SQLQuery1.ParamCheck := False;
      with SQLQuery1.SQL do begin
         Clear ;
         Add('DROP TABLE ' + TABLE1 + ';' );
      end;
      if not(SQLQuery1.Prepared) then SQLQuery1.Prepared := True ;
      SQLQuery1.ExecSQL;
      Result := True ;
   except
      ;
   end;
   SQLQuery1.Active := False ;
end;

// N
procedure TForm1.FormShow(Sender: TObject);
begin
   // vÔtH_擾܂
   AppPath := ExtractFilePath(ParamStr(0)) ;
   // f[^t@ĆAvOt@C̊gqu.datvɂ
   DatFile := ChangeFileExt(ParamStr(0),'.dat') ;
   OpenDatFile(DatFile) ;

   if (DBfold = '')or(DBname = '') then begin
      showMessage('f[^x[XݒsȂĉB');
      exit;
   end;
   if not(FileExists(DBfold+DBname)) then begin
      showMessage('f[^x[XݒsȂĉB');
      exit;
   end;

   // f[^x[Xڑ
   DataBaseConnect ;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   // f[^x[Xؒf
   DataBaseDisConnect ;
   //
   SaveDatFile(DatFile) ;
end;

// I
procedure TForm1.Button0Click(Sender: TObject);
begin
   close ;
end;

// f[^x[Xݒ
procedure TForm1.Button1Click(Sender: TObject);
begin
   // ̉ʂ
   Form3.Close ;
   Form4.Close ;
   Form5.Close ;
   // f[^x[Xؒf
   DataBaseDisConnect ;

   Form2.ShowModal ;

   // f[^x[Xڑ
   DataBaseConnect ;
end;

// f[^
procedure TForm1.Button2Click(Sender: TObject);
begin
   Form3.Show ;
end;

// f[^ҏW
procedure TForm1.Button3Click(Sender: TObject);
begin
   Form4.Show ;
end;

// f[^ꗗ\
procedure TForm1.Button4Click(Sender: TObject);
begin
    Form5.Show ;
end;

// f[^CSVo
procedure TForm1.Button5Click(Sender: TObject);
var
   fn : string ;
   F : TextFile ;
   m : Boolean ;  // True:TXT  False:CSV
   s : string ;
   i : integer ;
begin
   if not(SQLconnection1.Connected) then exit ; // ڑ
   if not(DataTableCheck(TABLE1)) then exit ;   // e[u

   if (SaveDialog1.Execute) then begin
      fn := SaveDialog1.FileName ;
      if (AnsiUpperCase(ExtractFileExt(fn)) = '') then begin
         if (SaveDialog1.FilterIndex = 1) then
            fn := fn + '.txt'
         else
            fn := fn + '.csv';
      end;
      if (AnsiUpperCase(ExtractFileExt(fn)) = '.CSV') then
         m := False
      else
         m := True ;
      //
      try
         AssignFile(F, fn);
         ReWrite(F);
         // Psڂ͍ږ
         if (m) then begin
            s := 'o^ԍ' + #9 + 'O' + #9 + 'O()' + #9
               + 'X֔ԍ1' + #9 + 'X֔ԍ2' + #9
               + 'Z1' + #9 + 'Z2' + #9 + 'dbԍ' + #9
               + 'FAXԍ' + #9 + 'gєԍ' + #9 + 'l';
         end
         else begin
            s := '"o^ԍ","O","O()","X֔ԍ1",'
               + '"X֔ԍ2","Z1","Z2","dbԍ",'
               + '"FAXԍ","gєԍ","l"';
         end;
         WriteLn(F, s);
         // Qsڈȍ~
         SQLQuery1.Active := False ;
         SQLQuery1.ParamCheck := True ;
         with SQLQuery1.SQL do begin
            Clear ;
            Add('SELECT * FROM '+TABLE1);
            Add('  ORDER BY N;');
         end;
         SQLQuery1.Open ;
         SQLQuery1.First ;
         while not(SQLQuery1.Eof) do begin
            s := SQLQuery1.Fields[0].AsString ;
            for i:=1 to 10 do begin
               if (m) then begin
                  s := s + #9 + SQLQuery1.Fields[i].AsString ;
               end
               else begin
                  s := s + ',"' + SQLQuery1.Fields[i].AsString + '"' ;
               end;
            end;
            WriteLn(F, s);
            SQLQuery1.Next ;
         end;
         SQLQuery1.Active := False ;

         CloseFile(F);
      except
         CloseFile(F);
         if TFile.Exists(fn) then TFile.Delete(fn);
      end;
   end;
end;

// f[^CSVǂݍ
procedure TForm1.Button6Click(Sender: TObject);
var
   fn : string ;
   F : TextFile ;
   s : string ;
   t : array[0..10] of string ;
   u : TStringList;
   i,j : integer ;
begin
   if not(SQLconnection1.Connected) then exit ; // ڑ
   // ̉ʂ
   Form3.Close ;
   Form4.Close ;
   Form5.Close ;
   //
   if (OpenDialog1.Execute) then begin
      fn := OpenDialog1.FileName ;
      if (AnsiUpperCase(ExtractFileExt(fn)) <> '.TXT')
      and(AnsiUpperCase(ExtractFileExt(fn)) <> '.CSV') then
         exit ;   // Sʂ̃t@CȂ̂Œf
      //
      if (Form1.DataTableCheck(TABLE1)) then begin
         // e[uꍇ͍폜
         if not(DataTableDelete1) then exit ;   // Ȃꍇ͒f
      end;
      // e[uVK쐬
      if not(DataTableMaking1) then exit ;   // 쐬oȂꍇ͒f
      //
      try
         AssignFile(F, fn);
         FileMode := 0;
         Reset(F);
         // 1sڂ͓ǂݔ΂
         ReadLn(F, s);
         // Qsڈȍ~
         u := TStringList.Create ;
         while not(Eof(F)) do begin
            ReadLn(F, s);
            for i:=0 to 10 do
               t[i] := '' ;
            // ڐ؂o
            u.CommaText := s ;
            j := u.Count ;
            if (j > 11) then j := 11 ;
            for i:=0 to j-1 do
               t[i] := u[i] ;
            // eڂo^oԂɂ
            if (t[0] = '') then t[0] := '0';
            for i:=1 to 10 do begin
               if (t[i] = '') then
                  t[i] := 'NULL'
               else
                  t[i] := '''' + t[i] + '''' ;
            end;
            // ǉo^
            try
               SQLQuery1.Close;
               SQLQuery1.ParamCheck := False ;
               with SQLQuery1.SQL do begin
                  Clear ;
                  Add('INSERT INTO ' + TABLE1 + ' (');
                  Add('  N, PNAME, PKANA, ZIP1, ZIP2,');
                  Add('  ADR1, ADR2, TEL, FAX, PHONE, BIKO)');
                  Add('VALUES (');
                  for i:=0 to 10 do begin
                     if (i < 10) then
                        s := '  ' + t[i] + ','
                     else
                        s := '  ' + t[i] + ');' ;
                     Add(s);
                  end;
               end;
               if not(SQLQuery1.Prepared) then SQLQuery1.Prepared := True;
               SQLQuery1.ExecSQL;
            except
               ;
            end;
            SQLQuery1.Active := False ;
         end;
         u.Free ;

         CloseFile(F);
      except
         CloseFile(F);
      end;
   end;
end;

end.
